 #include "pitches.h"
 
 #include <WellyNet.h>

#define COM_PIN 5 //AKA MISO
#define WN_ADDRESS 0x02
#define DND 4 //DND is sck line

WellyNet welly(COM_PIN,WN_ADDRESS);

int message[10];

const byte buzzerPin = 7;

int pitch[] = {
  NOTE_E5, NOTE_E3, NOTE_B4, NOTE_C5, NOTE_D5, NOTE_E5, NOTE_D5, NOTE_C5};/*, 
  NOTE_B4, NOTE_A4, NOTE_A3, NOTE_A4, NOTE_C5, NOTE_E5, NOTE_A3, NOTE_D5,
  NOTE_C5, NOTE_B4, NOTE_E4, NOTE_G4, NOTE_C5, NOTE_D5, NOTE_E3, NOTE_E5,
  NOTE_E3, NOTE_C5, NOTE_A3, NOTE_A4, NOTE_A3, NOTE_A4, NOTE_A3, NOTE_B2, 
  NOTE_C3, NOTE_D3, NOTE_D5, NOTE_F5, NOTE_A5, NOTE_C5, NOTE_C5, NOTE_G5, 
  NOTE_F5, NOTE_E5, NOTE_C3, 0, NOTE_C5, NOTE_E5, NOTE_A4, NOTE_G4, 
  NOTE_D5, NOTE_C5, NOTE_B4, NOTE_E4, NOTE_B4, NOTE_C5, NOTE_D5, NOTE_G4, 
  NOTE_E5, NOTE_G4, NOTE_C5, NOTE_E4, NOTE_A4, NOTE_E3, NOTE_A4, 0
};*/

byte noteDurations[] = {
  8,8,8,8,8,16,16,8};/*,
  8,8,8,8,8,8,8,8,
  8,8,8,8,8,8,8,8,
  8,8,8,8,8,8,8,8,
  8,8,4,8,8,16,16,8,
  8,8,8,8,8,8,16,16,
  8,8,8,8,8,8,8,8,
  8,8,8,8,8,8,4,4
};*/

void setup(){
  welly.begin(9600);
  
  pinMode(buzzerPin, OUTPUT);
  playTune(pitch[0], 500);
 // for (byte thisNote = 0; thisNote < 8; thisNote++) {
  //  playTune(pitch[thisNote], 1000/noteDurations[thisNote]);
  //}
}

void loop(){
   if (welly.getPacket(message)){ 
     for (byte thisNote = 0; thisNote < 8; thisNote++) {
    playTune(pitch[thisNote], 1000/noteDurations[thisNote]);
  }
     
     //int checksum = checksumCalc(message); //check the packet
     
     //if (message[9] != checksum) {  // value 9 is packet checksum
       //return;
     //}
     // Check the message checksum, bail if it doesn't match
     
     if(message_type(message) == 'E ') {
       playTune(pitch[0], 3000);
       //dispatch_event_message(message);
     } else {
       // Unknown message type 
     }
     
   }
}




void playTune(int pitch, int duration){
  unsigned long endTime = millis() + duration;
    while(endTime > millis()){
      digitalWrite(7, HIGH);
      delayMicroseconds(pitch);
      digitalWrite(7, LOW);
      delayMicroseconds(pitch);
    }
    delay(duration * 1.2);
}

uint16_t message_type(int message[]) { //combining packets 3 and 4
  return message[2];// message[3];
}

int message_payload(int message[]) {
  return message[4];
}

